import React from 'react';
import type { BottomTabBarProps } from '@react-navigation/bottom-tabs';
import type { TabBarAnimationConfigurableProps, TabsConfigsType } from './types';
interface AnimatedTabBarProps extends BottomTabBarProps, TabBarAnimationConfigurableProps {
    /**
     * Tabs configurations.
     */
    tabs: TabsConfigsType;
    /**
     * Overwrite background color of tabbar
     */
    barColor?: string;
    /**
     * Overwrite radius of dot
     */
    dotSize?: number;
    /**
     * Overwrite height of tabbar
     */
    barHeight?: number;
    /**
     * Overwrite width of tabbar
     */
    barWidth?: number;
    /**
     * Custom dot color
     */
    dotColor?: string;
    /**
     * Show title or not
     * @default false
     */
    titleShown?: boolean;
}
export declare const AnimatedTabBar: React.MemoExoticComponent<(props: AnimatedTabBarProps) => JSX.Element>;
export {};
